<?php

/**
 * @file
 * Contents \Drupal\files_upload\Form\FilesUploadForm
 */

namespace Drupal\files_upload\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 *	Class FilesUploadForm
 *	@package Drupal\files_upload\Form
 */
class FilesUploadForm extends FormBase {

	/**
	 *	{@inheritdoc}
	 */
	public function getFormId() {
		return 'message_time_settings_form';
	}

	/**
	 *	{@inheritdoc}
	 */
	public function buildForm(array $form, FormStateInterface $form_state) {

		$form['files_upload'] = array(
			'#type' => 'details',
			'#title' => $this->t('Files Upload'),
			'#open' => TRUE,
		);

		$form['files_upload']['image_dir'] = [
	    '#title' => t('Files'),
	    '#type' => 'managed_file',
	    '#upload_location' => 'public://',
	    '#multiple' => TRUE,
	    '#required' => TRUE,
	    '#description' => t('Allowed all type extensions.'),
	    '#upload_validators' => [
	      'file_validate_extensions' => [],
	      'file_validate_size' => 200000000,
	    ],
    ];

    $form['actions']['#type'] = 'actions';
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#button_type' => 'primary',
      '#default_value' => $this->t('Upload') ,
    ];

		return $form;
	}

	/**
	 *	{@inheritdoc}
	 */
	public function validateForm(array &$form, FormStateInterface $form_state) {

	}

	/**
	 *	{@inheritdoc}
	 */
	public function submitForm(array &$form, FormStateInterface $form_state) {
		$fids = $form_state->getValue(['files_upload' => 'image_dir']);
    $total = count($fids);
    $batch = [
      'title' => t('Files Upload...'),
      'operations' => [],
      'init_message' => t('Files upload process is starting.'),
      'progress_message' => t('Processed @current out of @total. Estimated time: @estimate.'),
      'error_message' => t('The process has encountered an error.'),
    ];
    foreach($fids as $fid) {
      $batch['operations'][] = [['\Drupal\files_upload\Form\FilesUploadForm', 'filesUploadBatchProcess'], [$fid]];
    }
    batch_set($batch);
    \Drupal::messenger()->addMessage($total . ' Files Uploaded.');

	}

	public static function filesUploadBatchProcess($fid, &$context){
    $message = 'Files Upload...';
    $results = array();
			$file = \Drupal\file\Entity\File::load($fid);
			$file_name = $file->getFilename();
			$file->setPermanent();
			$file->save();
    $context['message'] = $message;
    $context['results'] = $results;
  }

}
